From 6eeaeef36caf7e41e6c7481d96b36bae3c0ca882 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 05:14:03 +0000
Subject: [PATCH 823/2232] Run cargo metadata from top level crate's dir


When Cargo runs a build script, its current directory is set to the
manifest directory of the crate whose build script it is. That means if
crate A depends on crate B depends on cxx-build, the previous logic
would have found B's target dir (somewhere in the Cargo registry cache)
rather than the intended A target dir being used for the current build.

---

diff --git a/gen/build/src/cargo.rs b/gen/build/src/cargo.rs
index 6a4f1a6..b67c21b 100644
--- a/gen/build/src/cargo.rs
+++ b/gen/build/src/cargo.rs
@@ -1,12 +1,13 @@
 use crate::paths::TargetDir;
-use std::path::PathBuf;
+use std::path::{Path, PathBuf};
 use std::process::Command;
 use std::str;
 
-pub(crate) fn target_dir() -> TargetDir {
+pub(crate) fn target_dir(out_dir: &Path) -> TargetDir {
     (|| {
         let cargo = option_env!("CARGO").unwrap_or("cargo");
         let output = Command::new(cargo)
+            .current_dir(out_dir)
             .arg("metadata")
             .arg("--no-deps")
             .arg("--format-version=1")
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index b42bbe0..1628510 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -107,7 +107,7 @@ impl Project {
     fn init() -> Result<Self> {
         let out_dir = paths::out_dir()?;
 
-        let target_dir = match cargo::target_dir() {
+        let target_dir = match cargo::target_dir(&out_dir) {
             target_dir @ TargetDir::Path(_) => target_dir,
             // Fallback if Cargo did not work.
             TargetDir::Unknown => paths::search_parents_for_target_dir(&out_dir),

